{ ScrollWindow Alternate - Scroll using BIOS.               ver 3.4, 08-31-87 }
{ This is an alternate to the ScrollWindow procedure in WINDOW34.INC.  This
  one is about twice as fast.  Supposedly this is the correct way to do it,
  but the authors of the BIOS code on some machines didn't care about the
  annoying flicker.  It also uses about 250 bytes less of code.  If it works
  on your machine, great!  But if you plan on distributing code, better stick
  with WINDOW34.INC as is. }

{ =========================================================================== }
{ NAME: ScrollWindow - using BIOS                           ver 3.4, 08-31-87 }
{ DESCRIPTION: Scrolls a number of rows in a window.  Using a little          }
{              thought, you can see how this is better than the InsLine       }
{              and DelLine procedures.  This also works on any page, but      }
{              must be the currently viewed page.                             }
{ PARAMETERS:  RowBegin,RowEnd - Rows to be affected                          }
{              Dir             - 'Up' or 'Down'                               }
{ =========================================================================== }
procedure ScrollWindow (RowBegin,RowEnd: byte; Dir: DirType);
var BrdrWidth,r1,c1,r2,c2,Wattr,Service: byte;
begin
  with WndwStat[LI] do
  begin
    if WSbrdr=NoBrdr then
         BrdrWidth:=0
    else BrdrWidth:=1;
    r1 := WSrow+BrdrWidth+RowBegin-2;
    c1 := WScol+pred(BrdrWidth);
    r2 := r1+RowEnd-RowBegin;
    c2 := c1+pred(WScols)-(BrdrWidth shl 1);
    if Dir=Down then
         Service:=7
    else Service:=6;  { Up }
    Wattr:=WSWattr
  end;
Inline(                  {Assembly by Inline 08/24/87 18:08}
  $8A/$6E/<R1/           { mov   ch,[bp+<r1]      ;Move top row}
  $8A/$4E/<C1/           { mov   cl,[bp+<c1]      ;Move left col}
  $8A/$76/<R2/           { mov   dh,[bp+<r2]      ;Move bottom row}
  $8A/$56/<C2/           { mov   dl,[bp+<c2]      ;Move right col}
  $8A/$7E/<WATTR/        { mov   bh,[bp+<Wattr]   ;Attribute for blank row}
  $8A/$66/<SERVICE/      { mov   ah,[bp+<Service] ;For up or down scroll}
  $B0/$01/               { mov   al,$01           ;To scroll only 1 row}
  $55/                   { push  bp               ;Save Turbo's BP}
  $CD/$10/               { int   $10              ;Video interrupt}
  $5D);                  { pop   bp               ;Restore Turbo's BP}
end;
